package jseifried.xaspecteditor.dj;
import java.util.Vector;

import edu.neu.ccs.demeter.aplib.cd.ClassGraph;
class CDVisitor extends UniversalVisitor {
  protected XAspectLanguage xal;
  public XAspectLanguage get_xal() { return xal; }
  public void set_xal(XAspectLanguage new_xal) { xal = new_xal; }
  protected Vector names;
  public Vector get_names() { return names; }
  public void set_names(Vector new_names) { names = new_names; }
  protected Vector cgs;
  public Vector get_cgs() { return cgs; }
  public void set_cgs(Vector new_cgs) { cgs = new_cgs; }
  protected String errors;
  public String get_errors() { return errors; }
  public void set_errors(String new_errors) { errors = new_errors; }
  public CDVisitor() { super(); }
  public CDVisitor(XAspectLanguage xal, Vector names, Vector cgs, String errors) {
    super();
    set_xal(xal);
    set_names(names);
    set_cgs(cgs);
    set_errors(errors);
  }
  public static CDVisitor parse(java.io.Reader in) throws ParseException { return new Parser(in)._CDVisitor(); }
  public static CDVisitor parse(java.io.InputStream in) throws ParseException { return new Parser(in)._CDVisitor(); }
  public static CDVisitor parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }

   public void before(ClassDictionaryL host) {
    ClassGraph cg = ClassGraph.fromString(
      host.get_classdict().get_cdtext().toString());
    CDefVisitor cdefvisitor = 
      new CDefVisitor(cg, host.get_classdictionaryname().get_name(), "");
    cg.allClassDefs(cdefvisitor);
    names.add(host.get_classdictionaryname().get_name().toString());
    cgs.add(cg);
    set_errors(errors + cdefvisitor.get_errors());
   }    
 
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_xal(this, xal);
    xal.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_xal(this, xal);
    ((UniversalVisitor) _v_).before_names(this, names);
    ((UniversalVisitor) _v_).after_names(this, names);
    ((UniversalVisitor) _v_).before_cgs(this, cgs);
    ((UniversalVisitor) _v_).after_cgs(this, cgs);
    ((UniversalVisitor) _v_).before_errors(this, errors);
    ((UniversalVisitor) _v_).after_errors(this, errors);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
