package jseifried.xaspecteditor.dj;
import java.util.Enumeration;
import java.util.Vector;

import edu.neu.ccs.demeter.Ident;
import edu.neu.ccs.demeter.aplib.cd.ClassDef;
import edu.neu.ccs.demeter.aplib.cd.ClassDefVisitor;
import edu.neu.ccs.demeter.aplib.cd.ClassGraph;
class CDefVisitor extends ClassDefVisitor {
  protected ClassGraph cg;
  public ClassGraph get_cg() { return cg; }
  public void set_cg(ClassGraph new_cg) { cg = new_cg; }
  protected Ident cdname;
  public Ident get_cdname() { return cdname; }
  public void set_cdname(Ident new_cdname) { cdname = new_cdname; }
  protected String errors;
  public String get_errors() { return errors; }
  public void set_errors(String new_errors) { errors = new_errors; }
  public CDefVisitor() { super(); }
  public CDefVisitor(ClassGraph cg, Ident cdname, String errors) {
    super();
    set_cg(cg);
    set_cdname(cdname);
    set_errors(errors);
  }
  public static CDefVisitor parse(java.io.Reader in) throws ParseException { return new Parser(in)._CDefVisitor(); }
  public static CDefVisitor parse(java.io.InputStream in) throws ParseException { return new Parser(in)._CDefVisitor(); }
  public static CDefVisitor parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
 
   public void before(ClassDef host) {
    Vector edges = null;
    Object target = null;
    try {
     edges = new Vector(cg.getOutgoingEdges(host.toString()));
    } catch (Exception e) {System.err.println(e.getMessage());}

    for (Enumeration e = edges.elements() ; e.hasMoreElements() ;) {
     target = (
       (edu.neu.ccs.demeter.aplib.EdgeI)e.nextElement()).getTarget().toString();
     if(!cg.definesClass(target.toString())) {
      set_errors(errors + "CLASS DICTIONARY DEFINITION ERROR: Class \"" + 
        target.toString() + "\" not defined in ClassDictionary \"" + 
          cdname.toString() + "\".\n");
     }
    }
   }
 
  void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_cg(this, cg);
    ((UniversalVisitor) _v_).after_cg(this, cg);
    ((UniversalVisitor) _v_).before_cdname(this, cdname);
    ((UniversalVisitor) _v_).after_cdname(this, cdname);
    ((UniversalVisitor) _v_).before_errors(this, errors);
    ((UniversalVisitor) _v_).after_errors(this, errors);
    universal_trv0_aft(_v_);
  }

}
